<?php

namespace sdk;

class AvisAuthentiques
{
    const BASE_URL = 'https://api.avis-authentiques.fr';

    private $apiKey;

    public function __construct($apiKey)
    {
        $this->apiKey = $apiKey;
    }

    public function addOrder($reference, $customerEmail, $customerLastName, $customerFirstName)
    {
        $this->requestAPI('/orders', 'POST', [
            'reference'         => $reference,
            'customerEmail'     => $customerEmail,
            'customerLastName'  => $customerLastName,
            'customerFirstName' => $customerFirstName,
        ]);
    }

    private function requestAPI($endpoint, $method = 'GET', $data = [])
    {
        $curl = curl_init();

        switch ($method)
        {
            case "POST":
                curl_setopt($curl, CURLOPT_POST, 1);

                if ($data)
                    curl_setopt($curl, CURLOPT_POSTFIELDS, json_encode($data));
                break;
            case "PUT":
                curl_setopt($curl, CURLOPT_PUT, 1);
                break;
        }


        curl_setopt($curl, CURLOPT_HTTPHEADER, array('Content-Type:application/json', 'X-AUTH-API-KEY: ' . $this->apiKey));

        curl_setopt($curl, CURLOPT_URL, self::BASE_URL . $endpoint);
        if (_PS_MODE_DEV_ === true) {
            curl_setopt($curl, CURLOPT_SSL_VERIFYHOST, FALSE);
            curl_setopt($curl, CURLOPT_SSL_VERIFYPEER, FALSE);
        }
        curl_setopt($curl, CURLOPT_RETURNTRANSFER, 1);

        $result = curl_exec($curl);

        if($result === false)
        {
            echo 'Erreur Curl : ' . curl_error($curl);
        }

        curl_close($curl);


        return $result;
    }
}